#!/bin/sh

echo "echo $1"

if [ $1 -eq "111" ]; then
	echo "3_IN_1 VERSION, Continue ..."
else
	echo "OLD VERSION, OLD WAY TO UPGRADE ..."
	touch /usr/local/etc/firmware_upgrade_flag
fi

if [ -f /usr/local/etc/firmware_upgrade_flag ]; then
################################################################################
# Write Tuner Type to Magic                                                    #
################################################################################
	FIRMWARE_TYPE=NONE
	echo "***Remove Firmware Upgrade Flag****"
	rm -f /usr/local/etc/firmware_upgrade_flag
	rm -f /usr/local/etc/autoflag	
	# Find HDD #
	if [ -f /tmp/hdd/livepause/image/fw_upgrade_dvbt.sh ]; then
	    FIRMWARE_TYPE=DVBT
	    echo "DVBT Firmware Found from /tmp/hdd/livepause/image"
	elif [ -f /tmp/hdd/livepause/image/fw_upgrade_ntsc.sh ]; then
	    FIRMWARE_TYPE=NTSC
	    echo "NTSC Firmware Found from /tmp/hdd/livepause/image"
	elif [ -f /tmp/hdd/livepause/image/fw_upgrade.sh ]; then
	    FIRMWARE_TYPE=PAL
	    echo "PAL Firmware Found from /tmp/hdd/livepause/image"
	# Find HDD #
	elif [ -f /tmp/hdd/dvdvr/image/fw_upgrade_dvbt.sh ]; then
	    FIRMWARE_TYPE=DVBT
	    echo "DVBT Firmware Found from /tmp/hdd/dvdvr/image"
	elif [ -f /tmp/hdd/dvdvr/image/fw_upgrade_ntsc.sh ]; then
	    FIRMWARE_TYPE=NTSC
	    echo "NTSC Firmware Found from /tmp/hdd/dvdvr/image"
	elif [ -f /tmp/hdd/dvdvr/image/fw_upgrade.sh ]; then
	    FIRMWARE_TYPE=PAL
	    echo "PAL Firmware Found from /tmp/hdd/dvdvr/image"
	# Find USB #
	elif [ -f /tmp/ramfs/volumes/C:/image/fw_upgrade_dvbt.sh ]; then
	    FIRMWARE_TYPE=DVBT
	    echo "DVBT Firmware Found from /tmp/ramfs/volumes/C:/image"
	elif [ -f /tmp/ramfs/volumes/C:/image/fw_upgrade_ntsc.sh ]; then
	    FIRMWARE_TYPE=NTSC
	    echo "NTSC Firmware Found from /tmp/ramfs/volumes/C:/image"
	elif [ -f /tmp/ramfs/volumes/C:/image/fw_upgrade.sh ]; then
	    FIRMWARE_TYPE=PAL
	    echo "PAL Firmware Found from /tmp/ramfs/volumes/C:/image"
	# Find USB #
	elif [ -f /tmp/USB/image/fw_upgrade_dvbt.sh ]; then
	    FIRMWARE_TYPE=DVBT
	    echo "DVBT Firmware Found from /tmp/USB/image"
	elif [ -f /tmp/USB/image/fw_upgrade_ntsc.sh ]; then
	    FIRMWARE_TYPE=NTSC
	    echo "NTSC Firmware Found from /tmp/USB/image"
	elif [ -f /tmp/USB/image/fw_upgrade.sh ]; then
	    FIRMWARE_TYPE=PAL
	    echo "PAL Firmware Found from /tmp/USB/image"
	# Find USB #
	elif [ -f /mnt/usbmounts/sda1/image/fw_upgrade_dvbt.sh ]; then
	    FIRMWARE_TYPE=DVBT
	    echo "DVBT Firmware Found from /mnt/usbmounts/sda1/image"
	elif [ -f /mnt/usbmounts/sda1/image/fw_upgrade_ntsc.sh ]; then
	    FIRMWARE_TYPE=NTSC
	    echo "NTSC Firmware Found from /mnt/usbmounts/sda1/image"
	elif [ -f /mnt/usbmounts/sda1/image/fw_upgrade.sh ]; then
	    FIRMWARE_TYPE=PAL
	    echo "PAL Firmware Found from /mnt/usbmounts/sda1/image"
	# Find USB #
	elif [ -f /mnt/hdc/mnt/usbmounts/sda1/image/fw_upgrade_dvbt.sh ]; then
	    FIRMWARE_TYPE=DVBT
	    echo "DVBT Firmware Found from /mnt/hdc/mnt/usbmounts/sda1/image"
	elif [ -f /mnt/hdc/mnt/usbmounts/sda1/image/fw_upgrade_ntsc.sh ]; then
	    FIRMWARE_TYPE=NTSC
	    echo "NTSC Firmware Found from /mnt/hdc/mnt/usbmounts/sda1/image"
	elif [ -f /mnt/hdc/mnt/usbmounts/sda1/image/fw_upgrade.sh ]; then
	    FIRMWARE_TYPE=PAL
	    echo "PAL Firmware Found from /mnt/hdc/mnt/usbmounts/sda1/image"
	# Find tmp #
	elif [ -f /mnt/hdc/tmp/image/fw_upgrade_dvbt.sh ]; then
	    FIRMWARE_TYPE=DVBT
	    echo "DVBT Firmware Found from /mnt/hdc/tmp/image"
	elif [ -f /mnt/hdc/tmp/image/fw_upgrade_ntsc.sh ]; then
	    FIRMWARE_TYPE=NTSC
	    echo "NTSC Firmware Found from /mnt/hdc/tmp/image"
	elif [ -f /mnt/hdc/tmp/image/fw_upgrade.sh ]; then
	    FIRMWARE_TYPE=PAL
	    echo "PAL Firmware Found from /mnt/hdc/tmp/image"
	# Find tmp #
	elif [ -f /tmp/fw_upgrade_dvbt.sh ]; then
	    FIRMWARE_TYPE=DVBT
	    echo "DVBT Firmware Found from /tmp"
	elif [ -f /tmp/fw_upgrade_ntsc.sh ]; then
	    FIRMWARE_TYPE=NTSC
	    echo "NTSC Firmware Found from /tmp"
	elif [ -f /tmp/fw_upgrade.sh ]; then
	    FIRMWARE_TYPE=PAL
	    echo "PAL Firmware Found from /tmp"
	else
	    echo "Not Found Any Firmware."
	fi
	
	HW_VER=0
	TUNER_TYPE=0
	
	if [ -f /sys/realtek_boards/hwver ]; then
	    HW_VER=`cat /sys/realtek_boards/hwver`
	    echo "HW_VER=[$HW_VER]"
	fi
	
	if [ -f /sys/realtek_boards/tunertype ]; then
	    TUNER_TYPE=`cat /sys/realtek_boards/tunertype`
	    echo "TUNER_TYPE=[$TUNER_TYPE]"
	fi
	
	if [ "$HW_VER" = "0" ]; then
	    if [ "$FIRMWARE_TYPE" = "DVBT" ]; then
	        echo "Write DVBT to tuner_type"
	        echo DVBT > /usr/local/etc/tuner_type
	    elif [ "$FIRMWARE_TYPE" = "NTSC" ]; then
	        echo "Write NTSC to tuner_type"
	        echo NTSC > /usr/local/etc/tuner_type
	    elif [ "$FIRMWARE_TYPE" = "PAL" ]; then
	        echo "Write PAL to tuner_type"
	        echo PAL > /usr/local/etc/tuner_type
	    else
	        echo "Not Found Any Firmware."
	        echo PAL > /usr/local/etc/tuner_type
	    fi
	else
	    if [ "$TUNER_TYPE" = "49" ]; then
	        echo "Write PAL to tuner_type"
	        echo PAL > /usr/local/etc/tuner_type
	    elif [ "$TUNER_TYPE" = "50" ]; then
	        echo "Write NTSC to tuner_type"
	        echo NTSC > /usr/local/etc/tuner_type
	    elif [ "$TUNER_TYPE" = "51" ]; then
	        echo "Write DVBT to tuner_type"
	        echo DVBT > /usr/local/etc/tuner_type
	    else
	        echo "Tuner Not Found"
	    fi
	fi
	
	################################################################################
	# Run Prelude                                                                  #
	################################################################################
	mkdir /tmp/prelude
	cd /tmp/prelude
	if [ -f /tmp/hdd/livepause/image/prelude.tar ]; then
	    echo prelude from HDD
	    tar -xvf /tmp/hdd/livepause/image/prelude.tar
	elif [ -f /tmp/USB/image/prelude.tar ]; then
	    echo prelude from USB
	    tar -xvf /tmp/USB/image/prelude.tar
	elif [ -f /tmp/ramfs/volumes/C:/image/prelude.tar ]; then
	    echo prelude from USB
	    tar -xvf /tmp/ramfs/volumes/C:/image/prelude.tar
	elif [ -f /mnt/hdc/tmp/image/prelude.tar ]; then
	    echo prelude from RAMFS
	    tar -xvf /mnt/hdc/tmp/image/prelude.tar
	else
	    echo no prelude
	fi
	chown -R root /tmp/prelude/*
	
	#   Add your code in here
	chmod u+x /tmp/prelude/rcS
	mv /tmp/prelude/rcS /usr/local/etc/
    mv /tmp/prelude/profile /usr/local/etc/
	
	if [ ! -f /usr/local/etc/passwd ]; then
	    mv /tmp/prelude/passwd /usr/local/etc/
	fi
	
	if [ ! -f /usr/local/etc/group ]; then
	    mv /tmp/prelude/group /usr/local/etc/
	fi
	
	# End of you code
	
	cd /
	rm -rf /tmp/prelude
else 
	echo "*******REBOOT : READY TO UPGRADE****"
	touch /usr/local/etc/firmware_upgrade_flag
	touch /usr/local/etc/autoflag	
	sync
fi