################################################################################
#!/bin/sh
#   Please write down your comments, like what version and problem that you 
# expectwant to recover. For official release version. internal version is not
# necessary.
################################################################################

################################################################################
# Write Tuner Type to Magic                                                    #
################################################################################
FIRMWARE_TYPE=NONE

# Find HDD #
if [ -f /tmp/hdd/livepause/image/fw_upgrade_dvbt.sh ]; then
    FIRMWARE_TYPE=DVBT
    echo "DVBT Firmware Found from /tmp/hdd/livepause/image"
elif [ -f /tmp/hdd/livepause/image/fw_upgrade_ntsc.sh ]; then
    FIRMWARE_TYPE=NTSC
    echo "NTSC Firmware Found from /tmp/hdd/livepause/image"
elif [ -f /tmp/hdd/livepause/image/fw_upgrade.sh ]; then
    FIRMWARE_TYPE=PAL
    echo "PAL Firmware Found from /tmp/hdd/livepause/image"
# Find HDD #
elif [ -f /tmp/hdd/dvdvr/image/fw_upgrade_dvbt.sh ]; then
    FIRMWARE_TYPE=DVBT
    echo "DVBT Firmware Found from /tmp/hdd/dvdvr/image"
elif [ -f /tmp/hdd/dvdvr/image/fw_upgrade_ntsc.sh ]; then
    FIRMWARE_TYPE=NTSC
    echo "NTSC Firmware Found from /tmp/hdd/dvdvr/image"
elif [ -f /tmp/hdd/dvdvr/image/fw_upgrade.sh ]; then
    FIRMWARE_TYPE=PAL
    echo "PAL Firmware Found from /tmp/hdd/dvdvr/image"
# Find USB #
elif [ -f /tmp/ramfs/volumes/C:/image/fw_upgrade_dvbt.sh ]; then
    FIRMWARE_TYPE=DVBT
    echo "DVBT Firmware Found from /tmp/ramfs/volumes/C:/image"
elif [ -f /tmp/ramfs/volumes/C:/image/fw_upgrade_ntsc.sh ]; then
    FIRMWARE_TYPE=NTSC
    echo "NTSC Firmware Found from /tmp/ramfs/volumes/C:/image"
elif [ -f /tmp/ramfs/volumes/C:/image/fw_upgrade.sh ]; then
    FIRMWARE_TYPE=PAL
    echo "PAL Firmware Found from /tmp/ramfs/volumes/C:/image"
# Find USB #
elif [ -f /tmp/USB/image/fw_upgrade_dvbt.sh ]; then
    FIRMWARE_TYPE=DVBT
    echo "DVBT Firmware Found from /tmp/USB/image"
elif [ -f /tmp/USB/image/fw_upgrade_ntsc.sh ]; then
    FIRMWARE_TYPE=NTSC
    echo "NTSC Firmware Found from /tmp/USB/image"
elif [ -f /tmp/USB/image/fw_upgrade.sh ]; then
    FIRMWARE_TYPE=PAL
    echo "PAL Firmware Found from /tmp/USB/image"
# Find USB #
elif [ -f /mnt/usbmounts/sda1/image/fw_upgrade_dvbt.sh ]; then
    FIRMWARE_TYPE=DVBT
    echo "DVBT Firmware Found from /mnt/usbmounts/sda1/image"
elif [ -f /mnt/usbmounts/sda1/image/fw_upgrade_ntsc.sh ]; then
    FIRMWARE_TYPE=NTSC
    echo "NTSC Firmware Found from /mnt/usbmounts/sda1/image"
elif [ -f /mnt/usbmounts/sda1/image/fw_upgrade.sh ]; then
    FIRMWARE_TYPE=PAL
    echo "PAL Firmware Found from /mnt/usbmounts/sda1/image"
# Find USB #
elif [ -f /mnt/hdc/mnt/usbmounts/sda1/image/fw_upgrade_dvbt.sh ]; then
    FIRMWARE_TYPE=DVBT
    echo "DVBT Firmware Found from /mnt/hdc/mnt/usbmounts/sda1/image"
elif [ -f /mnt/hdc/mnt/usbmounts/sda1/image/fw_upgrade_ntsc.sh ]; then
    FIRMWARE_TYPE=NTSC
    echo "NTSC Firmware Found from /mnt/hdc/mnt/usbmounts/sda1/image"
elif [ -f /mnt/hdc/mnt/usbmounts/sda1/image/fw_upgrade.sh ]; then
    FIRMWARE_TYPE=PAL
    echo "PAL Firmware Found from /mnt/hdc/mnt/usbmounts/sda1/image"
# Find tmp #
elif [ -f /mnt/hdc/tmp/image/fw_upgrade_dvbt.sh ]; then
    FIRMWARE_TYPE=DVBT
    echo "DVBT Firmware Found from /mnt/hdc/tmp/image"
elif [ -f /mnt/hdc/tmp/image/fw_upgrade_ntsc.sh ]; then
    FIRMWARE_TYPE=NTSC
    echo "NTSC Firmware Found from /mnt/hdc/tmp/image"
elif [ -f /mnt/hdc/tmp/image/fw_upgrade.sh ]; then
    FIRMWARE_TYPE=PAL
    echo "PAL Firmware Found from /mnt/hdc/tmp/image"
# Find tmp #
elif [ -f /tmp/fw_upgrade_dvbt.sh ]; then
    FIRMWARE_TYPE=DVBT
    echo "DVBT Firmware Found from /tmp"
elif [ -f /tmp/fw_upgrade_ntsc.sh ]; then
    FIRMWARE_TYPE=NTSC
    echo "NTSC Firmware Found from /tmp"
elif [ -f /tmp/fw_upgrade.sh ]; then
    FIRMWARE_TYPE=PAL
    echo "PAL Firmware Found from /tmp"
else
    echo "Not Found Any Firmware."
fi

HW_VER=0
TUNER_TYPE=0

if [ -f /sys/realtek_boards/hwver ]; then
    HW_VER=`cat /sys/realtek_boards/hwver`
    echo "HW_VER=[$HW_VER]"
fi

if [ -f /sys/realtek_boards/tunertype ]; then
    TUNER_TYPE=`cat /sys/realtek_boards/tunertype`
    echo "TUNER_TYPE=[$TUNER_TYPE]"
fi

if [ "$HW_VER" = "0" ]; then
    if [ "$FIRMWARE_TYPE" = "DVBT" ]; then
        echo "Write DVBT to tuner_type"
        echo DVBT > /usr/local/etc/tuner_type
    elif [ "$FIRMWARE_TYPE" = "NTSC" ]; then
        echo "Write NTSC to tuner_type"
        echo NTSC > /usr/local/etc/tuner_type
    elif [ "$FIRMWARE_TYPE" = "PAL" ]; then
        echo "Write PAL to tuner_type"
        echo PAL > /usr/local/etc/tuner_type
    else
        echo "Not Found Any Firmware."
        echo PAL > /usr/local/etc/tuner_type
    fi
else
    if [ "$TUNER_TYPE" = "49" ]; then
        echo "Write PAL to tuner_type"
        echo PAL > /usr/local/etc/tuner_type
    elif [ "$TUNER_TYPE" = "50" ]; then
        echo "Write NTSC to tuner_type"
        echo NTSC > /usr/local/etc/tuner_type
    elif [ "$TUNER_TYPE" = "51" ]; then
        echo "Write DVBT to tuner_type"
        echo DVBT > /usr/local/etc/tuner_type
    else
        echo "Tuner Not Found"
    fi
fi

################################################################################
#   Recovery function created since v0.01.007 - 1.00.001 (First shipment) 
################################################################################
mkdir /tmp/recovery
cd /tmp/recovery
if [ -f /tmp/hdd/livepause/image/recovery.tar ]; then
    echo recovery from HDD
    tar -xvf /tmp/hdd/livepause/image/recovery.tar
elif [ -f /tmp/hdd/dvdvr/image/recovery.tar ]; then
    echo recovery from HDD
    tar -xvf /tmp/hdd/dvdvr/image/recovery.tar
elif [ -f /tmp/USB/image/recovery.tar ]; then
    echo recovery from USB
    tar -xvf /tmp/USB/image/recovery.tar
elif [ -f /tmp/ramfs/volumes/C:/image/recovery.tar ]; then
    echo recovery from USB
    tar -xvf /tmp/ramfs/volumes/C:/image/recovery.tar
elif [ -f /mnt/hdc/tmp/image/recovery.tar ]; then
    echo recovery from RAMFS
    tar -xvf /mnt/hdc/tmp/image/recovery.tar
else
    echo no recovery
fi
chown -R root /tmp/recovery/*

#   Add your code in here
touch /usr/local/etc/dvdplayer/fw_ver_cmp_flag
chmod u+x /tmp/recovery/rcS
chmod u+x /tmp/recovery/twonky.sh
mv /tmp/recovery/rcS /usr/local/etc/
mv /tmp/recovery/twonky.sh /usr/local/etc/
mv /tmp/recovery/profile /usr/local/etc/

#   Recover v1.00.001 DV fail problem and pre-setup SAMBA server required
# directory,v1.00.007 (Second shipment, does NOT support SAMBA server)
################################################################################
rm -rf /usr/local/etc/samba
mkdir -p /usr/local/etc/samba/lib
mv /tmp/recovery/smb.conf /usr/local/etc/samba/lib/
ln -sf /tmp/samba/private /usr/local/etc/samba/private
ln -sf /tmp/samba/var /usr/local/etc/samba/var


#   Recover v2.00.000 xxx problem
# x.xx.xxx (Third shipment)
################################################################################

if [ ! -f /usr/local/etc/passwd ]; then
    mv /tmp/recovery/passwd /usr/local/etc/
fi

if [ ! -f /usr/local/etc/group ]; then
    mv /tmp/recovery/group /usr/local/etc/
fi

# End of your code

cd /
rm -rf /tmp/recovery
